
static s8 Scale;
static s16 Pcm; // 12bitPCM -2047<=Pcm<=+2047

static inline void ADPCM_Init() {
  Scale=0;
  Pcm=0;
}

static inline u8 ADPCM_DecodeToPCM8(u8 adpcm)
{
#define MAXPCMVAL (2047)

  const s16 dltLTBL[48+1]={
    16,17,19,21,23,25,28,31,34,37,41,45,50,55,60,66,
    73,80,88,97,107,118,130,143,157,173,190,209,230,253,279,307,
    337,371,408,449,494,544,598,658,724,796,876,963,1060,1166,1282,1411,1552,
  };
  s16 dltL=dltLTBL[Scale];
  dltL=(dltL&((adpcm&4)?-1:0))+((dltL>>1)&((adpcm&2)?-1:0))+((dltL>>2)&((adpcm&1)?-1:0))+(dltL>>3);
  
  s16 sign=adpcm&8?-1:0;
  dltL=(dltL^sign)+(sign&1);
  Pcm+=dltL;
  
  if((u16)(Pcm+MAXPCMVAL)>(u16)(MAXPCMVAL*2)){
    if((s16)(Pcm+MAXPCMVAL)>=(s16)(MAXPCMVAL*2)){
      Pcm=MAXPCMVAL;
      }else{
      Pcm=-MAXPCMVAL;
    }
  }
  
  const s8 DCT[16]={
    -1,-1,-1,-1,2,4,6,8,
    -1,-1,-1,-1,2,4,6,8,
  };
  Scale+=DCT[adpcm];
  if((u8)Scale>(u8)48){
    if((s8)Scale>=(s8)48){
      Scale=48;
      }else{
      Scale=0;
    }
  }
  
  u8 pcm8=(Pcm+MAXPCMVAL)/16; // Signed12bitPCM -> Unsigned8bitPCM convertion
  
  return(pcm8);

#undef MAXPCMVAL
}

